﻿using Xamarin.Forms;
using System;
using Syncfusion.SfCalendar.XForms;
namespace CalendarCustom
{
    public partial class CalendarCustomPage : ContentPage
    {
        int i = 0;
        DateTime month = new DateTime();
        Label lbl,lbl1;
SfCalendar cal = new SfCalendar();
		public CalendarCustomPage()
        {
            InitializeComponent();
            
			CalendarEventCollection collection = new CalendarEventCollection();
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 6, 1), EndTime = new DateTime(2017, 6, 5) });
          	collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 6, 22), EndTime = new DateTime(2017, 6, 22) });
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 6, 12), EndTime = new DateTime(2017, 6, 13) });
			collection.Add(new CalendarInlineEvent() { Subject = "Meeting", StartTime = new DateTime(2017, 6, 15), EndTime = new DateTime(2017, 6, 18) });
			cal.DataSource = collection;
			cal.ShowInlineEvents = true;
			cal.OnMonthCellLoaded+=HandleMonthCellEventHandler;
            Content = cal;
        }

        void HandleMonthCellEventHandler(object sender, MonthCell args)
        {
			if (Device.RuntimePlatform == "Android")
			{

				bool call = false;
			for (int i = 0; i < cal.DataSource.Count; i++)
			{
                if((args.Date.Date.CompareTo(cal.DataSource[i].StartTime.Date) == 0 || args.Date.Date.CompareTo(cal.DataSource[i].StartTime.Date) == 1) && (args.Date.Date.CompareTo(cal.DataSource[i].EndTime.Date) == 0 || args.Date.Date.CompareTo(cal.DataSource[i].EndTime.Date) == -1))
                {
                    call = true;
                }
 
			}
             i++;
             
                string str = args.Date.ToString("dd");
                if (i == 1)
                {
                    month = args.Date.AddDays(21);
                }
				if (call)
				{
					if (month.Month == args.Date.Month)
					{
						
						lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.Black };
						lbl1 = new Label() { Text = "_", FontSize = 40, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.End, TextColor = Color.Red };
					}

					else
					{
						lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.LightGray };
						lbl1 = new Label() { Text = "_", FontSize = 40, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.End, TextColor = Color.Red };

					}
                    Grid DynamicGrid = new Grid();
                    DynamicGrid.HorizontalOptions = LayoutOptions.Center;
                    DynamicGrid.VerticalOptions = LayoutOptions.Center;
					RowDefinition gridRow1 = new RowDefinition();
					gridRow1.Height = new GridLength(29);
					RowDefinition gridRow2 = new RowDefinition();
					gridRow2.Height = new GridLength(20);
					RowDefinition gridRow3 = new RowDefinition();
					gridRow3.Height = new GridLength(20);
					DynamicGrid.RowDefinitions.Add(gridRow1);
					DynamicGrid.RowDefinitions.Add(gridRow2);
                    DynamicGrid.RowDefinitions.Add(gridRow3);
                    Grid.SetRow(lbl, 1);
                    Grid.SetRow(lbl1, 2);
					DynamicGrid.Children.Add(lbl1);
					DynamicGrid.Children.Add(lbl);
                    args.View = DynamicGrid;
				}
				else 
				{
					if (month.Month == args.Date.Month)
					{
						lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.Black };
					}

					else
					{
						lbl = new Label() { Text = str, FontSize = 15, HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, TextColor = Color.LightGray };
					}
					args.View = lbl;
				}
                if(i==42)
                {
                    i = 0;
                }
               
            }
        }
    }
}
